
#include "stdinc.h"
#include "server.h"
#include "extern.h"

#define NAME    "g_opers"
#define VERSION "$Id: g_opers.c 1287 2008-08-25 09:10:50Z twitch $"
#define AUTHOR  "Stranded and Jer"

#define PROTECT_MODES "+OAs"

static void cmd_opers (User *, char *);
static void cmd_protect (User *, char *);

static void help_opers_ext  (User*);
static void help_opers      (User*);
static void help_protect    (User*);
static void help_protect_ext(User*);


int Module_Init()
{
        int ch;

        RegisterModule(NAME,AUTHOR,VERSION,0,4,0);

        ch = AddCmd(s_Guardian, "OPERS", 0, cmd_opers);
	 AddHelp(s_Guardian, help_opers);
	 AddHelpExt(ch,s_Guardian, help_opers_ext);
	   
	 ch = AddCmd(s_Guardian, "PROTECT", ACC_OPER, cmd_protect);
        AddHelp(s_Guardian, help_protect);
	 AddHelpExt(ch, s_Guardian, help_protect_ext);
		
	return MOD_CONT;
}

void Module_Close()
{
        DelCmd(s_Guardian, "OPERS", cmd_opers);
        DelCmd(s_Guardian, "PROTECT", cmd_protect);
        return;
}



static void help_opers(User* u)
{
        sendto_one(s_Guardian,u,"OPERS   - IRC Operators list");
        return;
}

static void help_opers_ext(User* u)
{
        sendto_one(s_Guardian,u,"Syntax: \002OPERS\002");
        sendto_one(s_Guardian,u," ");
        sendto_one(s_Guardian,u," List all currently online IRC Operators connected");
        sendto_one(s_Guardian,u," to the network.");
        sendto_one(s_Guardian,u," ");
	return; //always return
}

/****************************************************/

static void cmd_opers (User *src, char *argv)
{
        User *u;
        dlink_node *dl;

	 int i = 0; //ircop count
	 int a = 0; //admin count
	 int inc = 0; //incrementor

	 int cnt = 0; //total IRCop + Admins
	
	 char *ircops[50];
	 char *admins[50];

        sendto_one(s_Guardian, src, "IRC Operators connected to the network");
        DLINK_FOREACH (dl, userlist.head)
	{
      		u = dl->data;
		if (!u->oper)
			continue;

       	if (u->service)
			continue;

		cnt++; //since were stripping out other things...
			//incrament the count here.

		if (u->admin)
			a++;
		else
			i++;

		sendto_one (s_Guardian, src, "[%d] \002%s\002 (%s) on %s", 
						cnt, u->nick, (u->admin)? "Server Administrator" : "IRC Operator", u->serv->name);

				
       }
	
	sendto_one(s_Guardian, src, "Currently \002%d\002 operators online [Admin: %d][IRCops: %d]",cnt,a,i);
       return;
}


static void cmd_protect (User *src, char *argv)
{
       int n;
       Channel* c;
       char* params[512];
       
       n = generictoken(' ',512,argv,params);
       if ((n >= 1) && (argv))
       {
       		if (!(c = find_channel(params[0])))
            {
   				sendto_one(s_Guardian,src,"Channel %s does not exsist.",params[0]);
				return;
            }
            
       		send_line(":%s MODE %s :%s",s_Guardian->nick,params[0],PROTECT_MODES);
       		sendto_one(s_Guardian,src,"Setting modes %s on channel %s",params[0],PROTECT_MODES);
       		return;
       }
       
       sendto_one(s_Guardian,src,"Invalid Paramaters - This command requires a paramater.");
       return;
}


static void help_protect(User *u)
{
	sendto_one(s_Guardian,u,"PROTECT    - Sets protection modes on a channel");
	return;
}
static void help_protect_ext(User *u)
{
	sendto_one(s_Guardian,u,"Syntax: \002PROTECT [CHANNEL]\002");
	sendto_one(s_Guardian,u," ");
	sendto_one(s_Guardian,u,"  Sets modes %s on the specified channel",PROTECT_MODES);
	sendto_one(s_Guardian,u," ");
	return;
}
