#include "stdinc.h"
#include "server.h"

#define NAME    "m_info"
#define AUTHOR  "Jer"
#define VERSION "$Id: m_info.c 1264 2008-08-19 01:15:39Z twitch $"

static void m_info (User *, int, char **);

enum MYVERSION {
       MAJOR = 0,
       MINOR = 4,
       PATCH = 0,

};

extern IRCDProto IRCd;

/*****************************************/
/**
 *  Module_Init() - Module factory called
 *                when the module is loaded.
 *   @param Module* - pointer to the module struct
 *                  for this current module.
 *   return void
 */

int Module_Init()
{
    RegisterModule(NAME,AUTHOR,VERSION, MAJOR, MINOR, PATCH);
    AddUserCmd ("INFO", m_info);
    return MOD_CONT;
}

int Module_Close()
{
	DelUserCmd("INFO", m_info);
	return;
}

static void m_info  (User *u, int argc, char **argv)
{
    sendto_one_numeric (CfgSettings.servername, u, 371, "'-------------------oOo-------------------'");                                  
    sendto_one_numeric (CfgSettings.servername, u, 371, "| %s(%s)-%s %s", PACKAGE_NAME, PACKAGE_VERSION, 
VERSION_STRING_DOTTED, CfgSettings.servername);
    sendto_one_numeric (CfgSettings.servername, u, 371, "|   ");    
    sendto_one_numeric (CfgSettings.servername, u, 371, "|  * Protocol: %s (%s)", IRCd.name, IRCd.author);
    sendto_one_numeric (CfgSettings.servername, u, 371, "|  * Birth Date: %s, compile #%s",COMPILE_DATE,BUILD);  
    sendto_one_numeric (CfgSettings.servername, u, 371, "|  * Compiled On: %s", SYSUNAME);
    sendto_one_numeric (CfgSettings.servername, u, 371, "|  * Configured with: %s", CONFIGURE_ARGS);
    sendto_one_numeric (CfgSettings.servername, u, 371, "|  * ModABI: %d",ABI_VERSION);    
    sendto_one_numeric (CfgSettings.servername, u, 371, "|  ");

#ifdef OMEGASTATS                    
	sendto_one_numeric (CfgSettings.servername, u, 371, "|  * Omega Statistical Reporting Enabled");
	sendto_one_numeric (CfgSettings.servername, u, 371, "|  ");
#endif

#ifdef USE_DEBUG_CMDS 
    sendto_one_numeric (CfgSettings.servername, u, 371, "|  ");                    
    sendto_one_numeric (CfgSettings.servername, u, 371, "|      ***************************   ");
    sendto_one_numeric (CfgSettings.servername, u, 371, "|      *        DEBUG MODE       *   ");
    sendto_one_numeric (CfgSettings.servername, u, 371, "|      ***************************   ");
    sendto_one_numeric (CfgSettings.servername, u, 371, "|  ");                    
#endif
    
    sendto_one_numeric (CfgSettings.servername, u, 371, "|  ");                    
    sendto_one_numeric (CfgSettings.servername, u, 371, "'-----------------------------------------'");  
    sendto_one_numeric (CfgSettings.servername, u, 371, "|   ");                               
    sendto_one_numeric (CfgSettings.servername, u, 371, "| \002Developers:\002");                                                     
    sendto_one_numeric (CfgSettings.servername, u, 371, "|  * twitch (mitch AT zomgirc DOT net)");                                       
    sendto_one_numeric (CfgSettings.servername, u, 371, "|  * jer (jeremy AT ssnet DOT ca)");   
    sendto_one_numeric (CfgSettings.servername, u, 371, "|   ");           
    sendto_one_numeric (CfgSettings.servername, u, 371, "| \002Contributers:\002");      
    sendto_one_numeric (CfgSettings.servername, u, 371, "|  * Rob (no email)");
    sendto_one_numeric (CfgSettings.servername, u, 371, "|  * Stranded (achmed AT randomnet DOT org) "); 
    sendto_one_numeric (CfgSettings.servername, u, 371, "|   ");         
    sendto_one_numeric (CfgSettings.servername, u, 371, "'-----------------------------------------'");                                
    sendto_one_numeric (CfgSettings.servername, u, 374, "End of /INFO");

    return;
}
