#include "stdinc.h"
#include "server.h"

extern User* user_list;
extern Link* serv_list; 
extern void do_restart(void);

void Users  (int);
void Info   (int);
void GenCore(int);
void SigHandler(int);

void SetSig() 
{ 
	signal(SIGINT,	SigHandler);
	signal(SIGTERM, SigHandler);
    signal(SIGUSR2, SigHandler);
    signal(SIGHUP,	SigHandler);

	signal(SIGPIPE, SIG_IGN);
	signal(SIGTRAP, SIG_IGN);

        if (backtrc == 1)
        {	
        	signal(SIGABRT, GenCore);
        	signal(SIGSEGV,GenCore);
		signal(SIGILL,GenCore);
        }
}

void SigHandler(int sig)
{
	alog(0,"Cought signal from consol - %d",sig);

	switch (sig)
	{
		case SIGHUP:
			Rehash(0);
			break;
		case SIGINT:
		case SIGTERM:
			Exit(0);
			break;
		case SIGUSR2:
			do_restart();
			break;
	}

}


void GenCore(int sig)
{
#ifdef HAVE_BACKTRACE
	FILE* f;
        void *info[10];
        size_t size, i;
        char **string;
  
        f = fopen("BACKTRACE","w+");
        size = backtrace (info, 10);
        string = (char**)  backtrace_symbols (info, size);
        for (i = 0; i < size; i++)
		fprintf(f,"%s\n",string[i]);

        fflush(f);
        fclose(f);
        free(string);
#endif
        abort();
}
